<?php

/**
 * Author: Nil Portugués Calderó <contact@nilportugues.com>
 * Date: 19/02/16
 * Time: 23:52.
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */
namespace NilPortugues\Foundation\Infrastructure\Model\Repository\MongoDB;

use NilPortugues\Serializer\DeepCopySerializer;
use NilPortugues\Serializer\Transformer\ArrayTransformer;

/**
 * Class ArrayTransformer.
 */
class MongoDBTransformer
{
    /**
     * @var ArrayTransformer
     */
    private static $instance;

    /**
     * @return ArrayTransformer
     */
    public static function create()
    {
        if (null === self::$instance) {
            self::$instance = new DeepCopySerializer(new ArrayTransformer());
        }

        return self::$instance;
    }
}
